/**
 * Ext GWT 3.0.0-beta3 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.desktop.client;

import com.sencha.gxt.core.client.Style.Anchor;
import com.sencha.gxt.core.client.Style.AnchorAlignment;
import com.sencha.gxt.widget.core.client.button.TextButton;
import com.sencha.gxt.widget.core.client.event.SelectEvent;
import com.sencha.gxt.widget.core.client.event.SelectEvent.SelectHandler;

public class StartButton extends TextButton {

  private StartMenu startMenu;
  private SelectHandler selectHandler;

  public StartButton() {
    super(new StartButtonCell());
    addSelectHandler(getSelectHandler());
  }

  public StartMenu getStartMenu() {
    if (startMenu == null) {
      startMenu = new StartMenu();
    }
    return startMenu;
  }

  private SelectHandler getSelectHandler() {
    if (selectHandler == null) {
      selectHandler = new SelectHandler() {
        @Override
        public void onSelect(SelectEvent event) {
          onStartButton();
        }
      };
    }
    return selectHandler;
  }

  private void onStartButton() {
    getStartMenu().show(getElement(), new AnchorAlignment(Anchor.BOTTOM_LEFT, Anchor.TOP_LEFT), new int[] {0, -5});

  }
}
