/**
 * Ext GWT 3.0.0-beta3 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.desktop.client;

import com.google.gwt.user.client.ui.Widget;
import com.sencha.gxt.desktop.client.theme.base.startmenu.StartMainMenuAppearance;
import com.sencha.gxt.widget.core.client.menu.Menu;

public class StartMainMenu extends Menu {

  private StartMenu startMenu;

  public StartMainMenu(StartMenu startMenu) {
    this(new StartMainMenuAppearance());
    this.startMenu = startMenu;
  }

  public StartMainMenu(StartMainMenuAppearance startMainMenuAppearance) {
    super(startMainMenuAppearance);
  }
  
  @Override
  public void add(Widget child) {
    if (!(child instanceof StartMainMenuItem)) {
      throw new IllegalArgumentException("Widget is not a StartMainMenuItem");
    }
    super.add(child);
  }

  @Override
  public void hide(boolean deep) {
    if (activeItem != null) {
      ((StartMainMenuItem)activeItem).deactivate();
      activeItem = null;
    }
    startMenu.hide();
  }
}