/**
 * Ext GWT 3.0.0-beta3 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.desktop.client;

import com.google.gwt.user.client.ui.Widget;
import com.sencha.gxt.desktop.client.theme.base.startmenu.StartToolMenuAppearance;
import com.sencha.gxt.widget.core.client.menu.Menu;

public class StartToolMenu extends Menu {

  private StartMenu startMenu;

  public StartToolMenu(StartMenu startMenu) {
    this(new StartToolMenuAppearance());
    this.startMenu = startMenu;
  }

  public StartToolMenu(StartToolMenuAppearance startToolMenuAppearance) {
    super(startToolMenuAppearance);
  }

  @Override
  public void add(Widget child) {
    if (!(child instanceof StartToolMenuItem)) {
      throw new IllegalArgumentException("Widget is not a StartToolMenuItem");
    }
    super.add(child);
  }

  @Override
  public void hide(boolean deep) {
    if (activeItem != null) {
      ((StartToolMenuItem)activeItem).deactivate();
      activeItem = null;
    }
    startMenu.hide();
  }
}