/**
 * Ext GWT 3.0.0-beta3 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.desktop.client.desktopapp;

import com.google.web.bindery.event.shared.HandlerRegistration;
import com.google.web.bindery.event.shared.SimpleEventBus;
import com.sencha.gxt.desktop.client.desktopapp.event.AddFileModelEvent;
import com.sencha.gxt.desktop.client.desktopapp.event.AddFileModelHandler;
import com.sencha.gxt.desktop.client.desktopapp.event.LoginEvent;
import com.sencha.gxt.desktop.client.desktopapp.event.LoginHandler;
import com.sencha.gxt.desktop.client.desktopapp.event.OpenFileModelEvent;
import com.sencha.gxt.desktop.client.desktopapp.event.OpenFileModelHandler;
import com.sencha.gxt.desktop.client.desktopapp.event.RemoveFileModelEvent;
import com.sencha.gxt.desktop.client.desktopapp.event.RemoveFileModelHandler;
import com.sencha.gxt.desktop.client.desktopapp.event.SelectFileModelEvent;
import com.sencha.gxt.desktop.client.desktopapp.event.SelectFileModelHandler;
import com.sencha.gxt.desktop.client.desktopapp.event.UpdateFileModelEvent;
import com.sencha.gxt.desktop.client.desktopapp.event.UpdateFileModelHandler;
import com.sencha.gxt.desktop.client.desktopapp.event.UpdateSettingsEvent;
import com.sencha.gxt.desktop.client.desktopapp.event.UpdateSettingsHandler;
import com.sencha.gxt.desktop.client.desktopapp.has.FireLoginEvent;
import com.sencha.gxt.desktop.client.desktopapp.has.FireUpdateSettingsEvent;
import com.sencha.gxt.desktop.client.service.login.LoginServiceProvider;
import com.sencha.gxt.desktop.client.service.login.LoginServiceRequest;
import com.sencha.gxt.desktop.client.service.settings.SettingsServiceProvider;
import com.sencha.gxt.desktop.client.service.settings.SettingsServiceRequest;
import com.sencha.gxt.desktop.client.servicebus.ServiceBus;

public class DesktopBus implements FireLoginEvent, FireUpdateSettingsEvent {
  private SimpleEventBus eventBus = new SimpleEventBus();
  private ServiceBus serviceBus = new ServiceBus();

  public HandlerRegistration addAddFileModelHandler(AddFileModelHandler handler) {
    return eventBus.addHandler(AddFileModelEvent.TYPE, handler);
  }

  public HandlerRegistration addLoginHandler(LoginHandler handler) {
    return eventBus.addHandler(LoginEvent.TYPE, handler);
  }

  public void addLoginService(LoginServiceProvider provider) {
    serviceBus.addServiceProvider(LoginServiceRequest.class, provider);
  }

  public HandlerRegistration addOpenFileModelHandler(OpenFileModelHandler handler) {
    return eventBus.addHandler(OpenFileModelEvent.TYPE, handler);
  }

  public HandlerRegistration addRemoveFileModelHandler(RemoveFileModelHandler handler) {
    return eventBus.addHandler(RemoveFileModelEvent.TYPE, handler);
  }

  public HandlerRegistration addSelectFileModelHandler(SelectFileModelHandler handler) {
    return eventBus.addHandler(SelectFileModelEvent.TYPE, handler);
  }

  public void addSettingsService(SettingsServiceProvider provider) {
    serviceBus.addServiceProvider(SettingsServiceRequest.class, provider);
  }

  public HandlerRegistration addUpdateFileModelHandler(UpdateFileModelHandler handler) {
    return eventBus.addHandler(UpdateFileModelEvent.TYPE, handler);
  }

  public HandlerRegistration addUpdateSettingsHandler(UpdateSettingsHandler handler) {
    return eventBus.addHandler(UpdateSettingsEvent.TYPE, handler);
  }

  public void fireAddFileModelEvent(AddFileModelEvent event) {
    eventBus.fireEvent(event);
  }

  public void fireLoginEvent(LoginEvent event) {
    eventBus.fireEvent(event);
  }

  public void fireOpenFileModelEvent(OpenFileModelEvent event) {
    eventBus.fireEvent(event);
  }

  public void fireRemoveFileModelEvent(RemoveFileModelEvent event) {
    eventBus.fireEvent(event);
  }

  public void fireSelectFileModelEvent(SelectFileModelEvent event) {
    eventBus.fireEvent(event);
  }

  public void fireUpdateFileModelEvent(UpdateFileModelEvent event) {
    eventBus.fireEvent(event);
  }

  @Override
  public void fireUpdateSettingsEvent(UpdateSettingsEvent event) {
    eventBus.fireEvent(event);
  }

  public void requestLoginService(Presenter presenter) {
    serviceBus.invoke(new LoginServiceRequest(presenter));
  }

  public void requestSettingsService(Settings settings) {
    serviceBus.invoke(new SettingsServiceRequest(settings));
  }
}
