/**
 * Ext GWT 3.0.0-beta3 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.desktop.client.desktopapp.event;

import com.google.gwt.event.shared.GwtEvent;
import com.sencha.gxt.desktop.client.desktopapp.persistence.FileModel;
import com.sencha.gxt.desktop.client.desktopapp.persistence.FileSystem;

public class OpenFileModelEvent extends GwtEvent<OpenFileModelHandler> {
  public static Type<OpenFileModelHandler> TYPE = new Type<OpenFileModelHandler>();
  private FileSystem fileSystem;
  private FileModel fileModel;

  public OpenFileModelEvent(FileSystem fileSystem, FileModel fileModel) {
    this.fileSystem = fileSystem;
    this.fileModel = fileModel;
  }

  @Override
  public Type<OpenFileModelHandler> getAssociatedType() {
    return TYPE;
  }

  public FileModel getFileModel() {
    return fileModel;
  }

  @Override
  protected void dispatch(OpenFileModelHandler handler) {
    handler.onOpenFileModel(this);
  }

  public FileSystem getFileSystem() {
    return fileSystem;
  }
}