/**
 * Ext GWT 3.0.0-beta3 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.desktop.client.desktopapp.filemanager;

import java.util.List;

import com.sencha.gxt.desktop.client.desktopapp.persistence.FileModel;
import com.sencha.gxt.desktop.client.desktopapp.persistence.FileSystem;
import com.sencha.gxt.dnd.core.client.DND.Feedback;
import com.sencha.gxt.dnd.core.client.DndDropEvent;
import com.sencha.gxt.dnd.core.client.TreeGridDropTarget;
import com.sencha.gxt.widget.core.client.treegrid.TreeGrid;

public class FileManagerDropTarget extends TreeGridDropTarget<FileModel> {

  private final FileSystem fileSystem;
  private boolean isMove;

  public FileManagerDropTarget(FileSystem fileSystem, TreeGrid<FileModel> tree) {
    super(tree);
    this.fileSystem = fileSystem;
    setAllowSelfAsSource(true);
    setFeedback(Feedback.BOTH);
  }

  @Override
  protected void appendModel(FileModel parent, List<?> items, int index) {
    if (isMove) {
      fileSystem.move(items, parent, index);
    } else {
      super.appendModel(parent, items, index);
    }
  }

  @Override
  protected void onDragDrop(DndDropEvent event) {
    if (event.getSource() instanceof FileManagerDragSource) {
      isMove = true;
      super.onDragDrop(event);
      isMove = false;
    }
  }
}