/**
 * Ext GWT 3.0.0-beta3 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.desktop.client.desktopapp.filemanager;

import com.google.gwt.cell.client.AbstractCell;
import com.google.gwt.safehtml.shared.SafeHtmlBuilder;
import com.sencha.gxt.desktop.client.desktopapp.persistence.FileModel;
import com.sencha.gxt.desktop.client.desktopapp.persistence.FileSystem;

public class FileManagerSizeCell extends AbstractCell<Long> {
  private FileSystem fileSystem;

  public FileManagerSizeCell(FileSystem fileSystem) {
    this.fileSystem = fileSystem;
  }

  @Override
  public void render(Context context, Long size, SafeHtmlBuilder sb) {
    if (size == null) {
      size = Long.valueOf(0);
    }
    sb.appendHtmlConstant(size.toString());
    String key = (String) context.getKey();
    FileModel fileModel = fileSystem.findModelWithKey(key);
    switch (fileModel.getFileType()) {
      case FOLDER:
        if (size == 1) {
          sb.appendHtmlConstant(" File");
        } else {
          sb.appendHtmlConstant(" Files");
        }
        break;
      default:
        if (size == 1) {
          sb.appendHtmlConstant(" Byte");
        } else {
          sb.appendHtmlConstant(" Bytes");
        }
        break;
    }
  }
}