/**
 * Ext GWT 3.0.0-beta3 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.desktop.client.desktopapp.persistence;

import com.google.gwt.storage.client.Storage;

// TODO: Consider decorator pattern for encryption layer support

public class StorageBackingStore implements BackingStore {

  private Storage storage;
  private String storageKeyPrefix;

  public StorageBackingStore(Storage storage, String storageKeyPrefix) {
    this.storage = storage;
    this.storageKeyPrefix = storageKeyPrefix;
  }

  @Override
  public void clear() {
    storage.clear();
  }

  @Override
  public String getItem(String key) {
    return storage.getItem(getStorageKey(key));
  }

  @Override
  public void removeItem(String key) {
    storage.removeItem(getStorageKey(key));
  }

  @Override
  public void setItem(String key, String data) {
    storage.setItem(getStorageKey(key), data);
  }

  private String getStorageKey(String key) {
    return storageKeyPrefix + "." + key;
  }

}
