/**
 * Ext GWT 3.0.0-beta3 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.desktop.client.service.login;

import com.sencha.gxt.desktop.client.desktopapp.has.FireLoginEvent;
import com.sencha.gxt.desktop.client.servicebus.ServiceProvider;

public class LoginServiceProvider implements ServiceProvider<LoginServiceRequest> {
  private FireLoginEvent fireLoginEvent;
  private LoginWindow loginWindow;

  public LoginServiceProvider(FireLoginEvent fireLoginEvent) {
    this.fireLoginEvent = fireLoginEvent;
  }

  @Override
  public void onServiceRequest(LoginServiceRequest loginServiceRequest) {
    getLoginWindow().show(loginServiceRequest.getPresenter());
  }

  private LoginWindow getLoginWindow() {
    if (loginWindow == null) {
      loginWindow = new LoginWindow(fireLoginEvent);
    }
    return loginWindow;
  }
}
