/**
 * Ext GWT 3.0.0-beta3 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.desktop.client.service.settings;

import com.sencha.gxt.desktop.client.desktopapp.has.FireUpdateSettingsEvent;
import com.sencha.gxt.desktop.client.servicebus.ServiceProvider;

public class SettingsServiceProvider implements ServiceProvider<SettingsServiceRequest> {
  private SettingsWindow settingsWindow;
  private FireUpdateSettingsEvent fireUpdateSettingsEvent;

  public SettingsServiceProvider(FireUpdateSettingsEvent fireUpdateSettingsEvent) {
    this.fireUpdateSettingsEvent = fireUpdateSettingsEvent;
  }

  @Override
  public void onServiceRequest(SettingsServiceRequest settingsServiceRequest) {
    getSettingsWindow().show(settingsServiceRequest.getSettings());
  }

  private SettingsWindow getSettingsWindow() {
    if (settingsWindow == null) {
      settingsWindow = new SettingsWindow(fireUpdateSettingsEvent);
    }
    return settingsWindow;
  }
}
