/**
 * Ext GWT 3.0.0-beta3 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.desktop.client.theme.base.startbutton;

import com.google.gwt.cell.client.Cell.Context;
import com.google.gwt.core.client.GWT;
import com.google.gwt.resources.client.ClientBundle;
import com.google.gwt.resources.client.ImageResource;
import com.google.gwt.safehtml.shared.SafeHtmlBuilder;
import com.sencha.gxt.cell.core.client.ButtonCell;
import com.sencha.gxt.desktop.client.StartButtonCell.StartButtonCellAppearance;
import com.sencha.gxt.theme.base.client.button.ButtonCellBaseAppearance;
import com.sencha.gxt.theme.base.client.frame.TableFrame.TableFrameResources;

public class StartButtonCellBaseAppearance<C> extends ButtonCellBaseAppearance<C> implements
    StartButtonCellAppearance<C> {

  public interface StartButtonCellBaseResources extends ButtonCellResources, ClientBundle {

    ImageResource startButtonIcon();

    @Source({"com/sencha/gxt/theme/base/client/button/ButtonCell.css", "StartButtonCell.css"})
    @Override
    StartButtonCellStyle style();
  }

  public interface StartButtonCellStyle extends ButtonCellStyle {
  }

  public StartButtonCellBaseAppearance() {
    super(GWT.<ButtonCellResources> create(StartButtonCellBaseResources.class),
        GWT.<TableFrameResources> create(StartButtonTableFrameResources.class));
  }

  @Override
  public void render(final ButtonCell<C> cell, Context context, C value, SafeHtmlBuilder sb) {
    cell.setIcon(((StartButtonCellBaseResources) resources).startButtonIcon());
    super.render(cell, context, value, sb);
  }

}
